#include <bits/stdc++.h>
using namespace std;
using ll = long long;
ll n;
ll e;
vector<pair<ll, ll>> l;
ll maxx[50000], ans, m;
ll checkCut(ll a){
    ll ans=0;
    for(ll i=0; i<n; i++) {
        if(l[i].first > a) break;
        ans+=(a >= l[i].first && l[i].second >= a+1);
    }
    return ans;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n;
    for(ll i=0; i<n; i++){
        l.push_back({});
        cin>>l[i].first>>l[i].second;
        e=max(e, l[i].second);
    }
    sort(l.begin(), l.end());
    for(ll i=0; i<e; i++) {
        maxx[i]=checkCut(i);
        m=max(m, maxx[i]);
    }
    for(ll i=0; i<e; i++) ans+=(maxx[i]==m);
    cout<<m<<"\n"<<ans<<"\n";
    return 0;
}
